minor new settings
[distro-setup] / .bashrc
1 # Copyright (C) 2016 Ian Kelling
2
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6
7 # http://www.apache.org/licenses/LICENSE-2.0
8
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 # to debug
16 #set -x
17 # redirect output to log file. this doesn't work. todo figure out why
18 #exec 1>>/a/tmp/bashlog
19 #exec 2>>/a/tmp/bashlog
20
21
22 # By default this file is sourced for ALL ssh commands. This is wonky.
23 # Normally, this file is not sourced when a script is run, but we can
24 # override that by having #!/bin/bash -l. I want something similar for ssh
25 # commands. when a local script runs an ssh command, this file should not be
26 # sourced by default, but we should be able to override that.
27 #
28 # so here we test for conditions of a script under ssh and return if so. To test
29 # for an overriding condition, we have a few options. one is to use an
30 # environment variable. env variables sent across ssh are strictly limited. ssh
31 # -t which sets $SSH_TTY, but within a script that won't work because tty
32 # allocation will fail. We could override an obscure unused LC_var, like
33 # telephone, but I don't want to run into some edge case where that messes
34 # things up. we could transfer a file which we could test for, but I can't think
35 # of a way to make that inherently limited to a single ssh command. I choose to
36 # set SendEnv and AcceptEnv ssh config vars to allow the environment variable
37 # BASH_LOGIN_SHELL to propagate across ssh.
38
39 # assume we want ssh commands to source this file if we are sourcing it,
40 # and we haven't specified otherwise already
41 [[ ! $BASH_LOGIN_SHELL ]] && export BASH_LOGIN_SHELL=true
42 #BASH_LOGIN_SHELL=false # temporary override
43
44 # first conditions show that we are an ssh command without an interactive shell
45 if [[ $SSH_CONNECTION ]] \
46 && [[ $- == *c* ]] \
47 && [[ ! $SSH_TTY ]] \
48 && [[ $- != *i* ]] \
49 && [[ ! $BASH_LOGIN_SHELL == true ]]; then
50 return
51 else
52 source /etc/profile
53 fi
54
55
56
57 # note, to catch errors in functions but not outside, do:
58 # set -E -o pipefail
59 # trap return ERR
60 # trap 'trap ERR' RETURN
61
62
63
64 ############
65 # settings #
66 ############
67
68 CDPATH=.
69
70 set -o pipefail
71
72 # remove all aliases. aliases provided by the system tend to get in the way,
73 # for example, error happens if I try to define a function the same name as an alias
74 unalias -a
75
76 # remove gnome keyring warning messages
77 # there is probably a more proper way, but I didn't find any easily on google
78 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
79 #unset GNOME_KEYRING_CONTROL
80
81 # use extra globing features.
82 shopt -s extglob
83 # include .files when globbing, but ignore files name . and ..
84 # setting this also sets dotglob.
85 # Note, this doesn't work in bash 4.4 anymore, for paths with
86 # more than 1 directory, like a/b/.foo, since * is fixed to not match /
87 export GLOBIGNORE=*/.:*/..
88
89 # broken with bash_completion package. Saw a bug for this once. Don't anymore.
90 # still broken in wheezy
91 # still buggered in latest stable from the web, version 2.1
92 # perhaps its fixed in newer git version, which fails to make for me
93 # this note is from 6-2014.
94 # Also, enabling this before sourcing .bashrc makes PATH be empty.
95 #shopt -s nullglob
96
97 # make tab on an empty line do nothing
98 shopt -s no_empty_cmd_completion
99
100 # advanced completion
101 # http://bash-completion.alioth.debian.org/
102 # might be sourced by the system already, but I've noticed it not being sourced before
103 if ! type _init_completion &> /dev/null && [[ -r "/usr/share/bash-completion/bash_completion" ]]; then
104 . /usr/share/bash-completion/bash_completion
105 fi
106
107
108 # fix spelling errors for cd, only in interactive shell
109 shopt -s cdspell
110 # append history instead of overwritting it
111 shopt -s histappend
112 # for compatibility, per gentoo/debian bashrc
113 shopt -s checkwinsize
114 # attempt to save multiline single commands as single history entries.
115 shopt -s cmdhist
116 # enable **
117 shopt -s globstar
118
119
120 # inside emacs fixes
121 if [[ $RLC_INSIDE_EMACS ]]; then
122 # EMACS is used by bash on startup, but we don't need it anymore.
123 # plus I hit a bug in a makefile which inherited it
124 unset EMACS
125 export RLC_INSIDE_EMACS
126 export PAGER=cat
127 export MANPAGER=cat
128 # scp completion does not work, but this doesn't fix it. todo, figure this out
129 complete -r scp &> /dev/null
130 # todo, remote file completion fails, figure out how to turn it off
131 export NODE_DISABLE_COLORS=1
132 # This get's rid of ugly terminal escape chars in node repl
133 # sometime, I'd like to have completion working in emacs shell for node
134 # the offending chars can be found in lib/readline.js,
135 # things that do like:
136 # stream.write('\x1b[' + (x + 1) + 'G');
137 # We can remove them and keep readline, for example by doing this
138 # to start a repl:
139 #!/usr/bin/env nodejs
140 # var readline = require('readline');
141 # readline.cursorTo = function(a,b,c) {};
142 # readline.clearScreenDown = function(a) {};
143 # const repl = require('repl');
144 # var replServer = repl.start('');
145 #
146 # no prompt, or else readline complete seems to be confused, based
147 # on our column being different? node probably needs to send
148 # different kind of escape sequence that is not ugly. Anyways,
149 # completion doesn't work yet even with the ugly prompt, so whatever
150 #
151 export NODE_NO_READLINE=1
152
153 fi
154
155
156 if [[ $- == *i* ]]; then
157 # for readline-complete.el
158 if [[ $RLC_INSIDE_EMACS ]]; then
159 # all for readline-complete.el
160 stty echo
161 bind 'set horizontal-scroll-mode on'
162 bind 'set print-completions-horizontally on'
163 bind '"\C-i": self-insert'
164 else
165 # arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
166 if [[ $TERM == "xterm" ]]; then
167 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
168 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
169 else
170 bind '"\eOc": shell-forward-word'
171 bind '"\eOd": shell-backward-word'
172 fi
173 # terminal keys: C-c, C-z. the rest defined by stty -a are, at least in
174 # gnome-terminal, overridden by bash, or disabled by the system
175 stty werase undef lnext undef stop undef start undef
176
177 fi
178
179 fi
180
181
182 # history number. History expansion is good.
183 PS4='$LINENO+ '
184 # history file size limit, set to unlimited.
185 # this needs to be different from the default because
186 # default HISTFILESIZE is 500 and could clobber our history
187 HISTFILESIZE=
188 # max commands 1 session can append/read from history
189 HISTSIZE=100000
190 # my own history size limit based on lines
191 HISTFILELINES=1000000
192 HISTFILE=$HOME/.bh
193 # the time format display when doing the history command
194 # also, setting this makes the history file record time
195 # of each command as seconds from the epoch
196 HISTTIMEFORMAT="%I:%M %p %m/%d "
197 # consecutive duplicate lines don't go in history
198 HISTCONTROL=ignoredups
199 # works in addition to HISTCONTROL to do more flexible things
200 # it could also do the same things as HISTCONTROL and thus replace it,
201 # but meh. dunno why, but just " *" does glob expansion, so use [ ] to avoid it.
202 HISTIGNORE='k *:[ ]*'
203
204 export BC_LINE_LENGTH=0
205
206
207 # note, if I use a machine I don't want files readable by all users, set
208 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
209
210 C_DEFAULT_DIR=/a
211
212
213 ###################
214 ## include files ###
215 ###################
216 for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
217 source "$_x"
218 done
219 unset _x
220 # so I can share my bashrc
221 for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
222 source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
223 source /a/bin/log-quiet/logq-function
224 path_add /a/exe
225 path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
226 # todo, these need to be renamed to be less generic.
227 # sync overrode something else useful
228 #path_add $HOME/bin/bash-programs-by-ian/utils
229
230
231
232 ###############
233 ### aliases ###
234 ###############
235
236 # very few aliases, functions are always preferred.
237
238 # ancient stuff.
239 if [[ $OS == Windows_NT ]]; then
240 alias ffs='cygstart "/c/Program Files (x86)/Mozilla Firefox/firefox.exe" -P scratch'
241 export DISPLAY=nt
242 alias j='command cygpath'
243 alias t='command cygstart'
244 alias cygstart='echo be quick, use the alias "t" instead :\)'
245 alias cygpath='echo be quick, use the alias "j" instead :\)'
246 fi
247
248
249
250 # keep this in mind? good for safety.
251 # alias cp='cp -i'
252 # alias mv='mv -i'
253
254
255 # remove any default aliases for these
256 unalias ls ll grep &>/dev/null ||:
257
258
259
260
261
262
263
264
265
266 #####################
267 ### functions ####
268 #####################
269
270
271
272
273 # file cut copy and paste, like the text buffers :)
274 # I havn't tested these.
275 _fbufferinit() { # internal use by
276 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
277 rm -rf "$my_f_tempdir"/*
278 }
279 fcp() { # file cp
280 _fbufferinit
281 cp "$@" "$my_f_tempdir"/
282 }
283 fct() { # file cut
284 _fbufferinit
285 mv "$@" "$my_f_tempdir"/
286 }
287 fpst() { # file paste
288 [[ $2 ]] && { echo too many arguments; return 1; }
289 target=${1:-.}
290 cp "$my_f_tempdir"/* "$target"
291 }
292
293
294 # todo, update this
295 complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
296
297
298 _cdiff-prep() {
299 # join options which are continued to multiples lines onto one line
300 local first=true
301 grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
302 # remove leading spaces/tabs. assumes extglob
303 if [[ $line == "[ ]*" ]]; then
304 line="${line##+( )}"
305 fi
306 if $first; then
307 pastline="$line"
308 first=false
309 elif [[ $line == *=* ]]; then
310 echo "$pastline" >> "$2"
311 pastline="$line"
312 else
313 pastline="$pastline $line"
314 fi
315 done
316 echo "$pastline" >> "$2"
317 }
318
319 _khfix_common() {
320 local h=${1##*@}
321 ssh-keygen -R $h -f $(readlink -f ~/.ssh/known_hosts)
322 local x=$(timeout 0.1 ssh -v $1 |& sed -rn "s/debug1: Connecting to $h \[([^\]*)].*/\1/p");
323 ssh-keygen -R $x -f $(readlink -f ~/.ssh/known_hosts)
324 }
325 khfix() { # known hosts fix
326 _khfix_common "$@"
327 ssh $1 :
328 }
329 khcopy() {
330 _khfix_common "$@"
331 ssh-copy-id $1
332 }
333
334 a() {
335 beet "${@}"
336 }
337
338 ack() { ack-grep "$@"; }
339
340 astudio() {
341 # googling android emulator libGL error: failed to load driver: r600
342 # lead to http://stackoverflow.com/a/36625175/14456
343 export ANDROID_EMULATOR_USE_SYSTEM_LIBS=1
344 /a/opt/android-studio/bin/studio.sh "$@" &r;
345 }
346
347 bashrcpush () {
348 local startdir="$PWD"
349 cd ~
350 for x in "$@"; do
351 ssh $x mkdir -p bin/distro-functions/src
352 tar cz bin/semi-private bin/distro-functions/src | ssh $x tar xz
353 done
354 cd $(mktemp -d)
355 command cp /a/c/repos/bash/!(.git|..|.) ~/.gitconfig .
356 for x in "$@"; do
357 tar cz * | ssh $x tar xz
358 done
359 cd "$startdir"
360 }
361
362 caa() { git commit --amend --no-edit -a; }
363
364 calc() { echo "scale=3; $*" | bc -l; }
365 # no having to type quotes, but also no command history:
366 clc() {
367 local x
368 read -r x
369 echo "scale=3; $x" | bc -l
370 }
371
372 cam() {
373 git commit -am "$*"
374 }
375
376 ccat () { # config cat. see a config without extra lines.
377 grep '^\s*[^[:space:]#]' "$@"
378 }
379
380 cdiff() {
381 # diff config files,
382 # setup for format of postfix, eg:
383 # option = stuff[,]
384 # [more stuff]
385 local pastline
386 local unified="$(mktemp)"
387 local f1="$(mktemp)"
388 local f2="$(mktemp)"
389 _cdiff-prep "$1" "$f1"
390 _cdiff-prep "$2" "$f2"
391 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
392 while IFS= read -r line; do
393 # the default bright red / blue doesn't work in emacs shell
394 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
395 done < "$unified"
396 }
397
398 cgpl()
399 {
400 if (($#)); then
401 cp /a/bin/data/COPYING "$@"
402 else
403 cp /a/bin/data/COPYING .
404 fi
405 }
406 capache()
407 {
408 if (($#)); then
409 cp /a/bin/data/LICENSE "$@"
410 else
411 cp /a/bin/data/LICENSE .
412 fi
413 }
414 chown() {
415 # makes it so chown -R symlink affects the symlink and its target.
416 if [[ $1 == -R ]]; then
417 shift
418 command chown -h "$@"
419 command chown -R "$@"
420 else
421 command chown "$@"
422 fi
423 }
424
425 cim() {
426 git commit -m "$*"
427 }
428
429 d() { builtin bg; }
430 complete -A stopped -P '"%' -S '"' d
431
432 dat() { # do all tee, for more complex scripts
433 tee >(ssh frodo bash -l) >(bash -l) >(ssh x2 bash -l) >(ssh tp bash -l)
434 }
435 da() { # do all
436 local host
437 "$@"
438 for host in x2 tp treetowl; do
439 ssh $host "$@"
440 done
441 }
442
443 dc() {
444 diff --strip-trailing-cr -w "$@" # diff content
445 }
446
447 debian_pick_mirror () {
448 # netselect-apt finds a fast mirror.
449 # but we need to replace the mirrors ourselves,
450 # because it doesn't do that. best it can do is
451 # output a basic sources file
452 # here we get the server it found, get the main server we use
453 # then substitute all instances of one for the other in the sources file
454 # and backup original to /etc/apt/sources.list-original.
455 # this is idempotent. the only way to identify debian sources is to
456 # note the original server, so we put it in a comment so we can
457 # identify it later.
458 local file=$(mktemp -d)/f # safe way to get file name without creating one
459 sudo netselect-apt -o "$file" || return 1
460 url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
461 sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
462 sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
463 sudo apt-get update
464 }
465
466 despace() {
467 local x y
468 for x in "$@"; do
469 y="${x// /_}"
470 safe_rename "$x" "$y"
471 done
472 }
473
474 dt() {
475 date "+%A, %B %d, %r" "$@"
476 }
477
478 dus() {
479 du -sh ${@:-*} | sort -h
480 }
481
482
483
484 e() { echo "$@"; }
485
486
487 ediff() {
488 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
489 emacs --eval "(ediff-files \"$1\" \"$2\")"
490 }
491
492
493 envload() { # load environment from a previous: export > file
494 local file=${1:-$HOME/.${USER}_env}
495 eval "$(export | sed 's/^declare -x/export -n/')"
496 while IFS= read -r line; do
497 # declare -x makes variables local to a function
498 eval ${line/#declare -x/export}
499 done < "$file"
500 }
501
502
503 fa() {
504 # find array. make an array of file names found by find into $x
505 # argument: find arguments
506 # return: find results in an array $x
507 while read -rd ''; do
508 x+=("$REPLY");
509 done < <(find "$@" -print0);
510 }
511
512 faf() { # find all files
513 find $@ -type f
514 }
515
516 fastboot() { /home/ian/Android/Sdk/platform-tools/fastboot "$@"; }
517
518 ff() {
519 if type -P firefox &>/dev/null; then
520 firefox "$@"
521 else
522 iceweasel "$@"
523 fi
524 }
525
526
527
528 fn() {
529 firefox -P alt "$@" >/dev/null 2>&1
530 }
531
532
533 fsdiff () {
534 local missing=false
535 local dname="${PWD##*/}"
536 local m="/a/tmp/$dname-missing"
537 local d="/a/tmp/$dname-diff"
538 [[ -e $d ]] && rm "$d"
539 [[ -e $m ]] && rm "$m"
540 local msize=0
541 local fsfile
542 while read -r line; do
543 fsfile="$1${line#.}"
544 if [[ -e "$fsfile" ]]; then
545 md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
546 else
547 missing=true
548 echo "$line" >> "$m"
549 msize=$((msize + 1))
550 fi
551 done < <(find -type f )
552 if $missing; then
553 echo "$m"
554 (( msize <= 100 )) && cat $m
555 fi
556 }
557 fsdiff-test() {
558 # expected output, with different tmp dirs
559 # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
560 # /a/tmp/tmp.qLDkYxBYPM-missing
561 # ./b
562 cd $(mktemp -d)
563 echo ok > a
564 echo nok > b
565 mkdir c
566 echo ok > c/d
567 local x=$(mktemp -d)
568 mkdir $x/c
569 echo different > $x/c/d
570 echo ok > $x/a
571 fsdiff $x
572 }
573 rename-test() {
574 # test whether missing files were renamed, generally for use with fsdiff
575 # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
576 # echos non-renamed files
577 local x y found
578 unset sums
579 for x in "$2"/*; do
580 { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
581 done
582 while read -r line; do
583 { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
584 renamed=false
585 for x in "${sums[@]}"; do
586 if [[ $missing_sum == "$x" ]]; then
587 renamed=true
588 break
589 fi
590 done
591 $renamed || echo "$line"
592 done < "$1"
593 return 0
594 }
595
596 feh() {
597 command feh -FzZ "$@"
598 }
599
600 funce() {
601 # like -e for functions. returns on error.
602 # at the end of the function, disable with:
603 # trap ERR
604 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
605 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
606 trap ERR
607 return' ERR
608 }
609
610
611 fw() {
612 firefox -P default "$@" >/dev/null 2>&1
613 }
614
615 getdir () {
616 local help="Usage: getdir [--help] PATH
617 Output the directory of PATH, or just PATH if it is a directory."
618 if [[ $1 == --help ]]; then
619 echo "$help"
620 return 0
621 fi
622 if [[ $# -ne 1 ]]; then
623 echo "getdir error: expected 1 argument, got $#"
624 return 1
625 fi
626 if [[ -d $1 ]]; then
627 echo "$1"
628 else
629 local dir="$(dirname "$1")"
630 if [[ -d $dir ]]; then
631 echo "$dir"
632 else
633 echo "getdir error: directory does not exist"
634 return 1
635 fi
636 fi
637 }
638
639 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
640 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
641 local gitroot
642 gitroot || return 1 # function to set gitroot
643 builtin cd "$gitroot"
644 git symbolic-ref HEAD refs/heads/$1
645 rm .git/index
646 git clean -fdx
647 }
648
649 gitroot() {
650 local help="Usage: gitroot [--help]
651 Print the full path to the root of the current git repo
652
653 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
654 and works in older versions of git which did not have that."
655 if [[ $1 == --help ]]; then
656 echo "$help"
657 return
658 fi
659 local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
660 [[ $p != /* ]] && p=$PWD
661 echo "${p%%/.git}"
662 }
663
664 # quit will prompt if the program crashes.
665 gmacs() { gdb -ex=r -ex=quit --args emacs "$@"; r; }
666
667 gse() {
668 git send-email --notes '--envelope-sender=<ian@iankelling.org>' \
669 --suppress-cc=self "$@"
670 }
671
672 gr() {
673 grep -iIP --color=auto "$@"
674 }
675
676 grr() {
677 if [[ ${#@} == 1 ]]; then
678 grep -riIP --color=auto "$@" .
679 else
680 grep -riIP --color=auto "$@"
681 fi
682 }
683
684 hstatus() {
685 # do git status on published repos
686 cd /a/bin/githtml
687 for x in !(forks) forks/* ian-specific/*; do
688 cd `readlink -f $x`/..
689 hr
690 echo $x
691 i status
692 cd /a/bin/githtml
693 done
694 }
695
696 hl() { # history limit. Write extra history to archive file.
697 # todo: this is not working or not used currently
698 local max_lines linecount tempfile prune_lines x
699 local harchive="${HISTFILE}_archive"
700 for x in "$HISTFILE" "$harchive"; do
701 [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
702 if [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID ]]; then
703 echo "error in hl: history file \$x:$x no good"
704 return 1
705 fi
706 done
707 history -a # save history
708 max_lines=$HISTFILELINES
709 [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
710 linecount=$(wc -l < $HISTFILE) # pipe so it doesn't output a filename
711 [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
712 if (($linecount > $max_lines)); then
713 prune_lines=$(($linecount - $max_lines))
714 head -n $prune_lines "$HISTFILE" >> "$harchive" \
715 && sed --follow-symlinks -ie "1,${prune_lines}d" $HISTFILE
716 fi
717 }
718
719 hr() { # horizontal row. used to break up output
720 printf "$(tput setaf 5)â–ˆ$(tput sgr0)%.0s" $(seq $COLUMNS)
721 echo
722 }
723
724 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
725
726
727 i() { git "$@"; }
728 # modified from ~/local/bin/git-completion.bash
729 # other completion commands are mostly taken from bash_completion package
730 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
731 || complete -o default -o nospace -F _git i
732
733 if ! type service &>/dev/null; then
734 service() {
735 echo actually running: systemctl $2 $1
736 systemctl $2 $1
737 }
738 fi
739
740 ic() {
741 # fast commit all
742 git commit -am "$*"
743 }
744
745
746 ifn() {
747 # insensitive find
748 find -L . -not \( -name .svn -prune -o -name .git -prune \
749 -o -name .hg -prune \) -iname "*$**" 2>/dev/null
750 }
751
752
753 if [[ $OS == Windows_NT ]]; then
754 # cygstart wrapper
755 cs() {
756 cygstart "$@" &
757 }
758 xp() {
759 explorer.exe .
760 }
761 # launch
762 o() {
763 local x=(*$1*)
764 (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
765 cygstart *$1* &
766 }
767 else
768 o() {
769 if type gvfs-open &> /dev/null ; then
770 gvfs-open "$@"
771 else
772 xdg-open "$@"
773 fi
774 # another alternative is run-mailcap
775 }
776 fi
777
778
779
780 istext() {
781 grep -Il "" "$@" &>/dev/null
782 }
783
784
785 l() {
786 if [[ $PWD == /[iap] ]]; then
787 command ls -A --color=auto -I lost+found "$@"
788 else
789 command ls -A --color=auto "$@"
790 fi
791 }
792
793
794 lcn() { locate -i "*$**"; }
795
796 lld() { ll -d "$@"; }
797
798 low() { # make filenames all lowercase
799 local x y
800 for x in "$@"; do
801 y=$(tr "[A-Z]" "[a-z]" <<<"$x")
802 [[ $y != $x ]] && mv "$x" "$y"
803 done
804 }
805
806
807
808
809 lower() { # make first letter of filenames lowercase.
810 local x
811 for x in "$@"; do
812 if [[ ${x::1} == [A-Z] ]]; then
813 y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
814 safe_rename "$x" "$y"
815 fi
816 done
817 }
818
819
820 k() { # history search
821 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 40;
822 }
823
824
825 make-targets() {
826 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
827 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
828 }
829
830
831 mkc() {
832 mkdir "$1"
833 c "$1"
834 }
835
836 mkdir() { command mkdir -p "$@"; }
837
838 pithos() {
839 cd /a/opt/Pithosfly/
840 python3 -m pithos&r
841 }
842
843 pakaraoke() {
844 # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
845 pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
846 }
847
848
849 pfind() { #find *$1* in $PATH
850 [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
851 local pathArray
852 IFS=: pathArray=($PATH); unset IFS
853 find "${pathArray[@]}" -iname "*$1*"
854 }
855
856 pick-trash() {
857 # trash-restore lists everything that has been trashed at or below CWD
858 # This picks out files just in CWD, not subdirectories,
859 # which also match grep $1, usually use $1 for a time string
860 # which you get from running restore-trash once first
861 local name x ask
862 local nth=1
863 # last condition is to not ask again for ones we skipped
864 while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
865 && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
866 name="$(echo "$name" | head -n $nth | tail -n 1 )"
867 read -p "$name [Y/n] " ask
868 if [[ ! $ask || $ask == [Yy] ]]; then
869 x=$( echo "$name" | gr -o "^\s*[0-9]*" )
870 echo $x | restore-trash > /dev/null
871 elif [[ $ask == [Nn] ]]; then
872 nth=$((nth+1))
873 else
874 return
875 fi
876 done
877 }
878
879 postconfin() {
880 local MAPFILE
881 mapfile -t
882 local s
883 [[ $EUID == 0 ]] || s=s
884 $s postconf -ev "${MAPFILE[@]}"
885 }
886
887 pub() {
888 rld /a/h/_site/ li:/var/www/iankelling.org/html
889 }
890
891 pubip() { curl -4s https://icanhazip.com; }
892 whatismyip() { pubip; }
893
894
895 pwgen() {
896 apg -m 12 -x 16 -t
897 }
898
899
900 q() { # start / launch a program in the backround and redir output to null
901 "$@" &> /dev/null &
902 }
903
904 r() {
905 exit "$@" 2>/dev/null
906 }
907
908 rbpipe() { rbt post -o --diff-filename=- "$@"; }
909 rbp() { rbt post -o "$@"; }
910
911 rl() {
912 # rsync, root is required to keep permissions right.
913 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
914 # --no-times --delete
915 # basically, make an exact copy, use checksums instead of file times to be more accurate
916 rsync -ahvic --delete "$@"
917 }
918 rld() {
919 # like rlu, but don't delete files on the target end which
920 # do not exist on the original end.
921 rsync -ahvic "$@"
922 }
923 complete -F _rsync -o nospace rld rl rlt
924
925 rlt() {
926 # rl without preserving modification time.
927 rsync -ahvic --delete --no-t "$@"
928 }
929
930 rlu() { # [OPTS] HOST PATH
931 # eg rlu -opts frodo /testpath
932 # useful for selectively sending dirs which have been synced with unison,
933 # where the path is the same on both hosts.
934 opts=("${@:1:$#-2}") # 1 to last -2
935 path="${@:$#}" # last
936 host="${@:$#-1:1}" # last -1
937 if [[ $path == .* ]]; then echo error: need absolut path; return 1; fi
938 # rync here uses checksum instead of time so we don't mess with
939 # unison relying on time as much. g is for group, same reason
940 # to keep up with unison.
941 s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
942 }
943
944
945 rspicy() { # usage: HOST DOMAIN
946 # connect to spice vm remote host. use vspicy for local host
947 local port=$(ssh $1<<EOF
948 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
949 sed -rn "s/.*port='([0-9]+).*/\1/p"
950 EOF
951 )
952 if [[ $port ]]; then
953 spicy -h $1 -p $port
954 else
955 echo "error: no port found. check that the domain is running."
956 fi
957 }
958
959 s() {
960 # background
961 # I use a function because otherwise we can't use in a script,
962 # can't assign to variable.
963 #
964 # note: gksudo is recommended for X apps because it does not set the
965 # home directory to the same, and thus apps writing to ~ fuck things up
966 # with root owned files.
967 #
968 if [[ $EUID != 0 || $1 == -* ]]; then
969 SUDOD="$PWD" sudo -i "$@"
970 else
971 "$@"
972 fi
973 }
974
975 safe_rename() {
976 if [[ $# != 2 ]]; then
977 echo safe_rename error: $# args, need 2 >2
978 return 1
979 elif [[ $1 != $2 ]]; then
980 if [[ -e $2 ]]; then
981 echo Cannot rename "$1" to "$2" as it already exists.
982 else
983 mv "$1" "$2"
984 fi
985 fi
986 }
987
988
989 sb() { # sudo bash -c
990 # use sb instead of s is for sudo redirections,
991 # eg. sb 'echo "ok fine" > /etc/file'
992 local SUDOD="$PWD"
993 sudo -i bash -c "$@"
994 }
995 complete -F _root_command s sb
996
997 scssl() {
998 # s gem install scss-lint
999 pushd /a/opt/thoughtbot-guides
1000 git pull --stat
1001 popd
1002 scss-lint -c /a/opt/thoughtbot-guides/style/sass/.scss-lint.yml "$@"
1003 }
1004
1005 ser() {
1006 local s; [[ $EUID != 0 ]] && s=sudo
1007 if type -p systemctl &>/dev/null; then
1008 $s systemctl $1 $2
1009 else
1010 $s service $2 $1
1011 fi
1012 }
1013
1014 sgo() { # service go
1015 service=$1
1016 ser restart $service
1017 if type -p systemctl &>/dev/null; then
1018 ser enable $service
1019 fi
1020 }
1021
1022
1023 shellck() {
1024 # 2086 = unquoted $var
1025 # 2046 = unquoted $(cmd)
1026 # i had -x as an arg, but debian testing(stretch) doesn't support it
1027 shellcheck -e 2086,2046,2068,2006,2119 "$@"
1028 }
1029
1030
1031 slog() {
1032 # log with script. timing is $1.t and script is $1.s
1033 # -l to save to ~/typescripts/
1034 # -t to add a timestamp to the filenames
1035 local logdir do_stamp arg_base
1036 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
1037 logdir="/a/dt/"
1038 do_stamp=false
1039 while getopts "lt" option
1040 do
1041 case $option in
1042 l ) arg_base=$logdir ;;
1043 t ) do_stamp=true ;;
1044 esac
1045 done
1046 shift $(($OPTIND - 1))
1047 arg_base+=$1
1048 [[ -e $logdir ]] || mkdir -p $logdir
1049 $do_stamp && arg_base+=$(date +%F.%T%z)
1050 script -t $arg_base.s 2> $arg_base.t
1051 }
1052 splay() { # script replay
1053 #logRoot="$HOME/typescripts/"
1054 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
1055 scriptreplay "$1.t" "$1.s"
1056 }
1057
1058 sr() {
1059 # sudo redo. be aware, this command may not work right on strange distros or earlier software
1060 if [[ $# == 0 ]]; then
1061 sudo -E bash -c -l "$(history -p '!!')"
1062 else
1063 echo this command redos last history item. no argument is accepted
1064 fi
1065 }
1066
1067 srm () {
1068 # with -ll, less secure but faster.
1069 command srm -ll "$@"
1070 }
1071
1072 srun() {
1073 scp $2 $1:/tmp
1074 ssh $1 /tmp/${2##*/} "${@:2}"
1075 }
1076
1077 t() {
1078 local x
1079 local -a args
1080 if type -t trash-put >/dev/null; then
1081 # skip args that don't exist, or else trash-put will have an error
1082 for x in "$@"; do
1083 if [[ -e $x || -L $x ]]; then
1084 args+=("$x")
1085 fi
1086 done
1087 [[ ! ${args[@]} ]] || trash-put "${args[@]}"
1088 else
1089 rm -rf "$@"
1090 fi
1091 }
1092
1093
1094 tclock() {
1095 clear
1096 date +%l:%_M
1097 len=60
1098 # this goes to full width
1099 #len=${1:-$((COLUMNS -7))}
1100 x=1
1101 while true; do
1102 if (( x == len )); then
1103 end=true
1104 d="$(date +%l:%_M) "
1105 else
1106 end=false
1107 d=$(date +%l:%M:%_S)
1108 fi
1109 echo -en "\r"
1110 echo -n "$d"
1111 for ((i=0; i<x; i++)); do
1112 if (( i % 6 )); then
1113 echo -n _
1114 else
1115 echo -n .
1116 fi
1117 done
1118 if $end; then
1119 echo
1120 x=1
1121 else
1122 x=$((x+1))
1123 fi
1124 sleep 5
1125 done
1126 }
1127
1128
1129 te() {
1130 # test existence / exists
1131 local ret=0
1132 for x in "$@"; do
1133 [[ -e "$x" || -L "$x" ]] || ret=1
1134 done
1135 return $ret
1136 }
1137
1138 tm() {
1139 # timer in minutes
1140 (sleep $(calc "$@ * 60") && mpv --volume 50 /a/bin/data/alarm.mp3 --loop=no) > /dev/null 2>&1 &
1141 }
1142
1143 ts() { # start editing a new file
1144 [[ $# != 1 ]] && echo "I need a filename." && return 1
1145 local quiet
1146 if [[ $- != *i* ]]; then
1147 quiet=true
1148 fi
1149 if [[ $1 == *.c ]]; then
1150 e '#include <stdio.h>' >"$1"
1151 e '#include <stdlib.h>' >>"$1"
1152 e 'int main(int argc, char * argv[]) {' >>"$1"
1153 e ' printf( "hello world\n");' >>"$1"
1154 e ' return 0;' >>"$1"
1155 e '}' >>"$1"
1156 e "${1%.c}: $1" > Makefile
1157 e " g++ -ggdb -std=gnu99 -o ${1%.c} $<" >> Makefile
1158 e "#!/bin/bash" >run.sh
1159 e "./${1%.c}" >>run.sh
1160 chmod +x run.sh
1161 elif [[ $1 == *.java ]]; then
1162 e "public class ${1%.*} {" >"$1"
1163 e ' public static void main(String[] args) {' >>"$1"
1164 e ' System.out.println("Hello, world!");' >>"$1"
1165 e ' }' >>"$1"
1166 e '}' >>"$1"
1167 else
1168 echo "#!/bin/bash" > "$1"
1169 chmod +x "$1"
1170 fi
1171 [[ $quiet ]] || g "$1"
1172 }
1173
1174
1175 tu() {
1176 local s;
1177 local dir="$(dirname "$1")"
1178 if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
1179 s=s;
1180 fi
1181 $s teeu "$@"
1182 }
1183
1184 tx() { # toggle set -x, and the prompt so it doesn't spam
1185 if [[ $- == *x* ]]; then
1186 set +x
1187 PROMPT_COMMAND=prompt_command
1188 else
1189 unset PROMPT_COMMAND
1190 PS1="\w \$ "
1191 set -x
1192 fi
1193 }
1194
1195 vc() {
1196 [[ $1 ]] || { e "$0: error, expected cmd to run"; return 1; }
1197 # manually run vpn so it stays within a network namespace,
1198 # until I get it all wired up with systemd.
1199 newns vpn start
1200 pid=$(< /run/openvpn/client.pid)
1201 vpn_on=false
1202 if [[ $pid ]]; then
1203 if [[ -e /proc/$pid ]]; then
1204 vpn_on=true
1205 else
1206 vpn_on=false
1207 s rm -f /run/openvpn/client.pid
1208 fi
1209 fi
1210 $vpn_on || s ip netns exec vpn /usr/sbin/openvpn --daemon ovpn --config /etc/openvpn/client.conf --cd /etc/openvpn --writepid /run/openvpn/client.pid
1211 gksudo -- ip netns exec vpn gksudo -u ${SUDO_USER:-$USER} "$@"
1212 }
1213
1214 transmission() {
1215 vc transmission-gtk&
1216 i=0
1217 while true; do
1218 if ((i > 10)); then
1219 echo "$0: error: vpn tun0 didn't show up"
1220 return 1
1221 fi
1222 tun_ip=$(s ip netns exec vpn ip a show dev tun0 | sed -rn 's/^ *inet (10\.8\.\S+).*/\1/p')
1223 [[ ! $tun_ip ]] || break
1224 sleep 1
1225 i=$((i + 1))
1226 done
1227 echo "$0: tun_ip=$tun_ip"
1228 [[ $tun_ip ]] || { e "$0: error: no tun0 addr found"; return 1; }
1229 ssh dopub bash <<EOF
1230 set -e
1231 rule="-A PREROUTING -i eth0 -p tcp -m tcp --dport 63324 -j DNAT --to-destination $tun_ip:63324"
1232 found=false
1233 while read -r line; do
1234 if [[ \$line == \$rule ]] && ! \$found; then
1235 found=true
1236 else
1237 iptables -t nat -D \${line#-A}
1238 fi
1239 done < <(iptables -t nat -S | grep -E -- '--dport\s+63324')
1240 \$found || iptables -t nat \$rule
1241 EOF
1242 }
1243
1244 virshrm() {
1245 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
1246 }
1247
1248 vm-set-listen(){
1249 local t=$(mktemp)
1250 local vm=$1
1251 local ip=$2
1252 s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
1253 sed -r "s/listen='[^']+/listen='$ip/"> $t
1254 s virsh undefine $vm
1255 s virsh define $t
1256 }
1257
1258
1259 vmshare() {
1260 vm-set-listen $1 0.0.0.0
1261 }
1262
1263
1264 vmunshare() {
1265 vm-set-listen $1 127.0.0.1
1266 }
1267
1268 vpn() {
1269 s systemctl start openvpn@client&
1270 journalctl --unit=openvpn@client -f -n0
1271 }
1272
1273
1274 vpnoff() {
1275 s systemctl stop openvpn@client
1276 }
1277
1278
1279 vrm() {
1280 virsh destroy $1
1281 virsh undefine $1
1282 }
1283
1284
1285
1286 vspicy() { # usage: VIRSH_DOMAIN
1287 # connect to vms made with virt-install
1288 spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
1289 sed -r "s/.*port='([0-9]+).*/\1/")
1290 }
1291
1292
1293 whatismyip() { curl ipecho.net/plain ; echo; }
1294
1295
1296 #############################
1297 ######### misc stuff ########
1298 #############################
1299
1300 if [[ $- == *i* ]]; then
1301 # commands to run when bash exits normally
1302 trap "hl; _smh" EXIT
1303 fi
1304
1305
1306 # temporary variables to test colorization
1307 # some copied from gentoo /etc/bash/bashrc,
1308 use_color=false
1309 # dircolors --print-database uses its own built-in database
1310 # instead of using /etc/DIR_COLORS. Try to use the external file
1311 # first to take advantage of user additions.
1312 safe_term=${TERM//[^[:alnum:]]/?} # sanitize TERM
1313 match_lhs=""
1314 [[ -f ~/.dir_colors ]] && match_lhs="${match_lhs}$(<~/.dir_colors)"
1315 [[ -f /etc/DIR_COLORS ]] && match_lhs="${match_lhs}$(</etc/DIR_COLORS)"
1316 [[ -z ${match_lhs} ]] \
1317 && type -P dircolors >/dev/null \
1318 && match_lhs=$(dircolors --print-database)
1319 # test if our $TERM is in the TERM values in dircolor
1320 [[ $'\n'${match_lhs} == *$'\n'"TERM "${safe_term}* ]] && use_color=true
1321
1322
1323 if ${use_color} && [[ $- == *i* ]]; then
1324
1325 if [[ $XTERM_VERSION == Cygwin* ]]; then
1326 get_term_color() {
1327 for x in "$@"; do
1328 case $x in
1329 underl) echo -n $'\E[4m' ;;
1330 bold) echo -n $'\E[1m' ;;
1331 red) echo -n $'\E[31m' ;;
1332 green) echo -n $'\E[32m' ;;
1333 blue) echo -n $'\E[34m' ;;
1334 cyan) echo -n $'\E[36m' ;;
1335 yellow) echo -n $'\E[33m' ;;
1336 purple) echo -n $'\E[35m' ;;
1337 nocolor) echo -n $'\E(B\E[m' ;;
1338 esac
1339 done
1340 }
1341
1342 else
1343 get_term_color() {
1344 for x in "$@"; do
1345 case $x in
1346 underl) echo -n $(tput smul) ;;
1347 bold) echo -n $(tput bold) ;;
1348 red) echo -n $(tput setaf 1) ;;
1349 green) echo -n $(tput setaf 2) ;;
1350 blue) echo -n $(tput setaf 4) ;;
1351 cyan) echo -n $(tput setaf 6) ;;
1352 yellow) echo -n $(tput setaf 3) ;;
1353 purple) echo -n $(tput setaf 5) ;;
1354 nocolor) echo -n $(tput sgr0) ;; # no font attributes
1355 esac
1356 done
1357 }
1358 fi
1359 else
1360 get_term_color() {
1361 :
1362 }
1363 fi
1364 # Try to keep environment pollution down, EPA loves us.
1365 unset safe_term match_lhs use_color
1366
1367
1368
1369
1370
1371
1372 ###############
1373 # prompt ######
1374 ###############
1375
1376
1377 if [[ $- == *i* ]]; then
1378 # git branch/status prompt function
1379 if [[ $OS != Windows_NT ]]; then
1380 GIT_PS1_SHOWDIRTYSTATE=true
1381 fi
1382 # arch source lopip show -fcation
1383 [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
1384 # fedora/debian source
1385 [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
1386
1387 # in case we didn't source git-prompt.sh
1388 if ! declare -f __git_ps1 > /dev/null; then
1389 __git_ps1() {
1390 :
1391 }
1392 fi
1393
1394 # this needs to come before next ps1 stuff
1395 # this stuff needs bash 4, feb 2009,
1396 # old enough to no longer condition on $BASH_VERSION anymore
1397 shopt -s autocd
1398 shopt -s dirspell
1399 PS1='\w'
1400 if [[ $- == *i* ]] && [[ ! $RLC_INSIDE_EMACS ]]; then
1401 PROMPT_DIRTRIM=2
1402 bind -m vi-command B:shell-backward-word
1403 bind -m vi-command W:shell-forward-word
1404 fi
1405
1406 if [[ $SSH_CLIENT ]]; then
1407 PS1="\h $PS1"
1408 fi
1409
1410 prompt_command() {
1411 local return=$? # this MUST COME FIRST
1412 local psc pst
1413 local ps_char ps_color
1414 unset IFS
1415 history -a # save history
1416 if [[ ! $DESKTOP_SESSION == xmonad && $TERM == *(screen*|xterm*|rxvt*) ]]; then
1417 # from the screen man page
1418 if [[ $TERM == screen* ]]; then
1419 local title_escape="\033]..2;"
1420 else
1421 local title_escape="\033]0;"
1422 fi
1423 echo -ne "$title_escape${PWD/#$HOME/~} $USER@$HOSTNAME\007"
1424 fi
1425
1426 case $return in
1427 0) ps_color="$(get_term_color blue)"
1428 ps_char='\$'
1429 ;;
1430 1) ps_color="$(get_term_color green)"
1431 ps_char="$return \\$"
1432 ;;
1433 *) ps_color="$(get_term_color yellow)"
1434 ps_char="$return \\$"
1435 ;;
1436 esac
1437 if [[ ! -O . ]]; then # not owner
1438 if [[ -w . ]]; then # writable
1439 ps_color="$(get_term_color bold red)"
1440 else
1441 ps_color="$(get_term_color bold green)"
1442 fi
1443 fi
1444 PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
1445 # emacs completion doesn't like the git prompt atm, so disabling it.
1446 #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
1447 }
1448 PROMPT_COMMAND=prompt_command
1449 fi
1450
1451
1452
1453 ###########################################
1454 # stuff that makes sense to be at the end #
1455 ###########################################
1456 if [[ "$SUDOD" ]]; then
1457 cd "$SUDOD"
1458 unset SUDOD
1459 elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
1460 cd /a
1461 fi
1462
1463
1464 # best practice
1465 unset IFS
1466
1467
1468 # if someone exported $SOE, catch errors
1469 if [[ $SOE ]]; then
1470 errcatch
1471 fi
1472
1473 # I'd prefer to have system-wide, plus user ruby, due to bug in it
1474 # https://github.com/rubygems/rubygems/pull/1002
1475 # further problems: installing multi-user ruby and user ruby,
1476 # you don't get multi-user ruby when you sudo to root, unless its sudo -i.
1477 # There a third hybrid form, which passenger error suggested I use,
1478 # but it didn't actually work.
1479
1480 # in cased I never need this
1481 # rvm for non-interactive shell: modified from https://rvm.io/rvm/basics
1482 #if [[ $(type -t rvm) == file && ! $(type -t ruby) ]]; then
1483 # source $(rvm 1.9.3 do rvm env --path)
1484 #fi
1485
1486 # based on warning from rvmsudo
1487 export rvmsudo_secure_path=1
1488
1489 # for other script I wrote
1490 #export ACME_TINY_PATH=/a/opt/acme-tiny
1491 export ACME_TINY_WRAPPER_CERT_DIR=/p/c/machine_specific/$HOSTNAME/webservercerts
1492
1493 if [[ -s "/usr/local/rvm/scripts/rvm" ]]; then
1494 source "/usr/local/rvm/scripts/rvm"
1495 elif [[ -s $HOME/.rvm/scripts/rvm ]]; then
1496 source $HOME/.rvm/scripts/rvm
1497 fi
1498
1499
1500 path_add --end ~/.npm-global
1501
1502
1503 # didn't get drush working, if I did, this seems like the
1504 # only good thing to include for it.
1505 # Include Drush completion.
1506 # if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
1507 # source /home/ian/.drush/drush.complete.sh
1508 # fi
1509
1510
1511 # https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
1512 # i added an extra condition as gentoo xorg guide says depending on
1513 # $DISPLAY is fragile.
1514 if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
1515 exec startx
1516 fi
1517
1518
1519 # ensure no bad programs appending to this file will have an affect
1520 return 0